
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import com.java4less.rbarcode.BarCode;
import com.java4less.rbarcode.BarCodeEncoder;

import java.awt.print.PageFormat;
import java.awt.print.Pageable;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;

public class Barcode1DDemo extends JFrame implements Pageable ,Printable  {
  JPanel barcodePanel = new JPanel();
  JLabel jLabel1 = new JLabel();
  JTextField txtCode = new JTextField();
  JComboBox comboType = new JComboBox();
  JComboBox comboUPCSystem = new JComboBox();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JComboBox comboCode128 = new JComboBox();
  JLabel jLabel5 = new JLabel();
  JTextField txtExtraheight = new JTextField();
  JTextField txtPostnetShortBar = new JTextField();
  JTextField txtPostnetTallbar = new JTextField();
  JTextField txtCodeBarEnd = new JTextField();
  JTextField txtCodeBarStart = new JTextField();
  JTextField txtSuplement = new JTextField();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel7 = new JLabel();
  JLabel jLabel8 = new JLabel();
  JLabel jLabel9 = new JLabel();
  JLabel jLabel10 = new JLabel();
  JTextField txtN = new JTextField();
  JTextField txtH = new JTextField();
  JTextField txtX = new JTextField();
  JTextField txtTop = new JTextField();
  JTextField txtLeft = new JTextField();
  JTextField txtI = new JTextField();
  JLabel jLabel11 = new JLabel();
  JLabel jLabel12 = new JLabel();
  JLabel jLabel13 = new JLabel();
  JLabel jLabel14 = new JLabel();
  JLabel jLabel15 = new JLabel();
  JLabel jLabel16 = new JLabel();
  JLabel jLabel17 = new JLabel();
  JLabel jLabel18 = new JLabel();
  JTextField txtHeight = new JTextField();
  JLabel jLabel19 = new JLabel();
  JCheckBox chkDrawText = new JCheckBox();
  JCheckBox chkSuplement2 = new JCheckBox();
  JCheckBox chkSuplement5 = new JCheckBox();
  JCheckBox chkGuardBars = new JCheckBox();
  JCheckBox chkTextOnTop = new JCheckBox();
  JButton btnApply = new JButton();
  JButton btnSave = new JButton();
  JButton btnPrint = new JButton();
  JButton btnQuit = new JButton();
  
  BarCode bc= new BarCode();
  PrinterJob printerJob=null;
  public Barcode1DDemo() {
	try {
	  jbInit();
	  userInit();
	}
	catch(Exception e) {
	  e.printStackTrace();
	}
  }
  public static void main(String[] args) {
	Barcode1DDemo barcode1DTest1 = new Barcode1DDemo();
	barcode1DTest1.show();
  }
  private void jbInit() throws Exception {
	this.getContentPane().setLayout(null);
	barcodePanel.setLayout(new java.awt.BorderLayout());
	barcodePanel.setBackground(Color.white);
	barcodePanel.setBorder(BorderFactory.createEtchedBorder());
	barcodePanel.setBounds(new Rectangle(6, 8, 444, 222));
	jLabel1.setText("Code");
	jLabel1.setBounds(new Rectangle(10, 241, 53, 17));
	txtCode.setText("123456780123");
	txtCode.setBounds(new Rectangle(89, 240, 170, 21));
	comboType.setBounds(new Rectangle(88, 265, 171, 21));
	comboUPCSystem.setBounds(new Rectangle(88, 292, 171, 21));
	jLabel3.setText("UPC System");
	jLabel3.setBounds(new Rectangle(10, 296, 72, 17));
	jLabel4.setToolTipText("");
	jLabel4.setText("Suplement");
	jLabel4.setBounds(new Rectangle(10, 348, 73, 17));
	comboCode128.setBounds(new Rectangle(88, 318, 171, 21));
	jLabel5.setText("Left");
	jLabel5.setBounds(new Rectangle(275, 241, 48, 17));
	txtExtraheight.setText("10");
	txtExtraheight.setBounds(new Rectangle(178, 477, 85, 21));
	txtPostnetShortBar.setText("10");
	txtPostnetShortBar.setBounds(new Rectangle(178, 451, 85, 21));
	txtPostnetTallbar.setText("20");
	txtPostnetTallbar.setBounds(new Rectangle(178, 424, 85, 21));
	txtCodeBarEnd.setText("B");
	txtCodeBarEnd.setBounds(new Rectangle(178, 395, 85, 21));
	txtCodeBarStart.setText("A");
	txtCodeBarStart.setBounds(new Rectangle(178, 368, 85, 21));
	txtSuplement.setBounds(new Rectangle(88, 342, 172, 21));
	jLabel6.setBounds(new Rectangle(10, 320, 70, 17));
	jLabel6.setText("Code128");
	jLabel7.setBounds(new Rectangle(10, 423, 111, 17));
	jLabel7.setText("Postnet tall bar");
	jLabel8.setBounds(new Rectangle(10, 373, 146, 17));
	jLabel8.setText("Codabar start char.");
	jLabel9.setText("Type");
	jLabel9.setBounds(new Rectangle(10, 267, 48, 17));
	jLabel10.setBounds(new Rectangle(10, 241, 53, 17));
	jLabel10.setText("Code");
	txtN.setText("2");
	txtN.setBounds(new Rectangle(357, 342, 85, 21));
	txtH.setText("0.3");
	txtH.setBounds(new Rectangle(357, 318, 85, 21));
	txtX.setText("1");
	txtX.setBounds(new Rectangle(357, 292, 85, 21));
	txtTop.setText("20");
	txtTop.setBounds(new Rectangle(357, 265, 85, 21));
	txtLeft.setText("20");
	txtLeft.setBounds(new Rectangle(357, 240, 85, 21));
	txtI.setText("1");
	txtI.setBounds(new Rectangle(357, 368, 85, 21));
	jLabel11.setText("Extra height");
	jLabel11.setBounds(new Rectangle(10, 478, 145, 16));
	jLabel12.setText("Codabar end char.");
	jLabel12.setBounds(new Rectangle(10, 396, 146, 17));
	jLabel13.setText("Postnet short bar");
	jLabel13.setBounds(new Rectangle(10, 451, 111, 17));
	jLabel14.setBounds(new Rectangle(275, 265, 48, 17));
	jLabel14.setText("Top");
	jLabel15.setBounds(new Rectangle(275, 297, 48, 17));
	jLabel15.setText("X");
	jLabel16.setBounds(new Rectangle(275, 320, 48, 17));
	jLabel16.setText("H");
	jLabel17.setBounds(new Rectangle(275, 348, 48, 17));
	jLabel17.setText("N");
	jLabel18.setBounds(new Rectangle(275, 373, 48, 17));
	jLabel18.setText("I");
	txtHeight.setText("0");
	txtHeight.setBounds(new Rectangle(358, 395, 85, 21));
	jLabel19.setText("Bar Height");
	jLabel19.setBounds(new Rectangle(275, 396, 70, 17));
	chkDrawText.setSelected(true);
	chkDrawText.setText("Draw text");
	chkDrawText.setBounds(new Rectangle(11, 508, 90, 25));
	chkSuplement2.setText("UPC/EAN Suplement 2");
	chkSuplement2.setHorizontalTextPosition(SwingConstants.LEADING);
	chkSuplement2.setBounds(new Rectangle(278, 423, 167, 25));
	chkSuplement5.setBounds(new Rectangle(278, 449, 167, 25));
	chkSuplement5.setHorizontalTextPosition(SwingConstants.LEADING);
	chkSuplement5.setText("UPC/EAN Suplement 5");
	chkGuardBars.setBounds(new Rectangle(278, 474, 167, 29));
	chkGuardBars.setHorizontalTextPosition(SwingConstants.LEADING);
	chkGuardBars.setText("Guard bars");
	chkTextOnTop.setBounds(new Rectangle(277, 504, 167, 25));
	chkTextOnTop.setHorizontalTextPosition(SwingConstants.LEADING);
	chkTextOnTop.setText("Text on top");
	btnApply.setText("Apply");
	btnApply.setBounds(new Rectangle(42, 546, 79, 27));
	btnApply.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		btnApply_actionPerformed(e);
	  }
	});
	btnSave.setText("Save");
	btnSave.setBounds(new Rectangle(129, 546, 79, 27));
	btnSave.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		btnSave_actionPerformed(e);
	  }
	});
	btnPrint.setText("Print");
	btnPrint.setBounds(new Rectangle(217, 546, 79, 27));
	btnPrint.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		btnPrint_actionPerformed(e);
	  }
	});
	btnQuit.setText("Quit");
	btnQuit.setBounds(new Rectangle(303, 546, 79, 27));
	btnQuit.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		btnQuit_actionPerformed(e);
	  }
	});
	this.getContentPane().add(jLabel1, null);
	this.getContentPane().add(txtCode, null);
	this.getContentPane().add(comboType, null);
	this.getContentPane().add(comboUPCSystem, null);
	this.getContentPane().add(comboCode128, null);
	this.getContentPane().add(txtExtraheight, null);
	this.getContentPane().add(txtPostnetShortBar, null);
	this.getContentPane().add(txtPostnetTallbar, null);
	this.getContentPane().add(txtCodeBarEnd, null);
	this.getContentPane().add(txtCodeBarStart, null);
	this.getContentPane().add(txtSuplement, null);
	this.getContentPane().add(jLabel6, null);
	this.getContentPane().add(jLabel9, null);
	this.getContentPane().add(jLabel10, null);
	this.getContentPane().add(txtLeft, null);
	this.getContentPane().add(txtN, null);
	this.getContentPane().add(txtTop, null);
	this.getContentPane().add(txtX, null);
	this.getContentPane().add(txtH, null);
	this.getContentPane().add(txtI, null);
	this.getContentPane().add(jLabel3, null);
	this.getContentPane().add(jLabel4, null);
	this.getContentPane().add(jLabel8, null);
	this.getContentPane().add(barcodePanel, null);
	this.getContentPane().add(jLabel12, null);
	this.getContentPane().add(jLabel7, null);
	this.getContentPane().add(jLabel11, null);
	this.getContentPane().add(jLabel13, null);
	this.getContentPane().add(jLabel5, null);
	this.getContentPane().add(jLabel14, null);
	this.getContentPane().add(jLabel15, null);
	this.getContentPane().add(jLabel16, null);
	this.getContentPane().add(jLabel17, null);
	this.getContentPane().add(jLabel18, null);
	this.getContentPane().add(txtHeight, null);
	this.getContentPane().add(jLabel19, null);
	this.getContentPane().add(chkDrawText, null);
	this.getContentPane().add(chkSuplement2, null);
	this.getContentPane().add(chkSuplement5, null);
	this.getContentPane().add(chkGuardBars, null);
	this.getContentPane().add(chkTextOnTop, null);
	this.getContentPane().add(btnSave, null);
	this.getContentPane().add(btnPrint, null);
	this.getContentPane().add(btnQuit, null);
	this.getContentPane().add(btnApply, null);
	
	
  }

  void userInit() {

	this.setBackground(java.awt.Color.lightGray);


	this.comboType.addItem("CODE39");
	this.comboType.addItem("CODE39EXT");
	this.comboType.addItem("INTERLEAVED25");
	this.comboType.addItem("CODE11");
	this.comboType.addItem("CODABAR");
	this.comboType.addItem("MSI");
	this.comboType.addItem("UPCA");
	this.comboType.addItem("INDUSTRIAL25");
	this.comboType.addItem("MATRIX25");
	this.comboType.addItem("CODE93");
	this.comboType.addItem("EAN13");
	this.comboType.addItem("EAN8");
	this.comboType.addItem("UPCE");
	this.comboType.addItem("CODE128");
	this.comboType.addItem("CODE93EXT");
	this.comboType.addItem("POSTNET");
	this.comboType.addItem("EAN128");
	this.comboType.setSelectedIndex(0);

	
	this.comboCode128.addItem("A");
	this.comboCode128.addItem("B");
	this.comboCode128.addItem("C");
	this.comboCode128.setSelectedIndex(0);
	
	this.comboUPCSystem.addItem("0");
	this.comboUPCSystem.addItem("1");
	this.comboUPCSystem.setSelectedIndex(0);
    
	this.setSize(465,620);
	this.setLocation(100,100);
	this.setTitle("RBarcode 1D Demo");

	applyData();

	barcodePanel.add(bc);

	}
	// load data into barcode object
	void applyData() {

	  bc.resolution=1;
	  bc.checkCharacter=true;
	  bc.topMarginCM=getInt(this.txtTop.getText(),0);
	  bc.leftMarginCM=getInt(this.txtLeft.getText(),0);
  
  	  bc.barType=this.comboType.getSelectedIndex();
  	  if (this.comboUPCSystem.getSelectedIndex()==0) bc.UPCESytem='0';
  	  else bc.UPCESytem='1';
  	  
  	  bc.barHeightCM=getInt(this.txtHeight.getText(),0);
  	  if (this.txtCodeBarStart.getText().length()>0) bc.CODABARStartChar=this.txtCodeBarStart.getText().charAt(0);
	  if (this.txtCodeBarEnd.getText().length()>0) bc.CODABARStopChar=this.txtCodeBarEnd.getText().charAt(0);
  	  //bc.codeSup=this.txtSuplement.getText();
  	  //bc.supHeight=0;
  	  bc.supplement=this.txtSuplement.getText();
  	  bc.Code128Set='A';
  	  if (this.comboCode128.getSelectedIndex()==1) bc.Code128Set='B';
	  if (this.comboCode128.getSelectedIndex()==2) bc.Code128Set='C';
	  
	  bc.H=getDouble(this.txtH.getText(),0.45);
	  bc.I=getInt(this.txtI.getText(),0);
	  bc.X=getInt(this.txtX.getText(),1);
	  bc.guardBars=this.chkGuardBars.isSelected();
	  bc.N=getInt(this.txtN.getText(),2);
	  bc.postnetHeightShortBar=getInt(this.txtPostnetShortBar.getText(),10);
	  bc.postnetHeightTallBar=getInt(this.txtPostnetTallbar.getText(),20);
	  bc.textOnTop=this.chkTextOnTop.isSelected();
	  if (this.chkDrawText.isSelected()) bc.textFont=new Font("Arial",Font.PLAIN,11);
	  else bc.textFont=null;
	  bc.UPCEANSupplement2=this.chkSuplement2.isSelected();
	  bc.UPCEANSupplement5=this.chkSuplement5.isSelected();

	  bc.code=txtCode.getText();
    

	}
	
	private int getInt(String s,int idefault) {
		try {
		
		return new Integer(s).intValue();
		
		} catch (Exception e){
			
		}
		return idefault;
	}
	
	private double getDouble(String s,double idefault) {
		try {
		
		return new Double(s).doubleValue();
		
		} catch (Exception e){
			
		}
		return idefault;
	}	


  void btnApply_actionPerformed(ActionEvent e) {
	applyData();
	this.paintAll(this.getGraphics());
	this.repaint();
	this.barcodePanel.paintAll(this.barcodePanel.getGraphics());
	this.barcodePanel.setVisible(false);
	this.barcodePanel.setVisible(true);
  }

  void btnSave_actionPerformed(ActionEvent e) {
	this.applyData();
	FileDialog f=new FileDialog(this,"Select JPG File",FileDialog.SAVE);

   f.show();

   if (f.getFile()!=null) {
	   String fi=f.getDirectory()+f.getFile();
	   System.out.println(fi);
	   BarCodeEncoder   be=  new BarCodeEncoder(bc,"JPG",fi);

	 }
  }

  void btnPrint_actionPerformed(ActionEvent e) {
	printerJob=PrinterJob.getPrinterJob();
	printerJob.setJobName("RBarcode");
	
	printerJob.setPageable(this);
	if (!printerJob.printDialog()) return;
	
	try {
		printerJob.print();
	} catch (PrinterException e1) {
		// TODO Auto-generated catch block
		e1.printStackTrace();
	}
	
	this.applyData();
  }

  void btnQuit_actionPerformed(ActionEvent e) {
	System.exit(0);
  }
  
  /* (non-Javadoc)
   * @see java.awt.print.Pageable#getNumberOfPages()
   */
  public int getNumberOfPages() {
	  return 1;
  }
  /* (non-Javadoc)
   * @see java.awt.print.Pageable#getPageFormat(int)
   */
  public PageFormat getPageFormat(int pageIndex) throws IndexOutOfBoundsException {
	return printerJob.defaultPage();
  }
  /* (non-Javadoc)
   * @see java.awt.print.Pageable#getPrintable(int)
   */
  public Printable getPrintable(int pageIndex) throws IndexOutOfBoundsException {
	  return this;
  }
  /* (non-Javadoc)
   * @see java.awt.print.Printable#print(java.awt.Graphics, java.awt.print.PageFormat, int)
   */
  public int print(Graphics graphics, PageFormat pageFormat, int pageIndex) throws PrinterException {
	
	  bc.leftMarginCM=printerJob.defaultPage().getImageableWidth()/2;
	  bc.topMarginCM=printerJob.defaultPage().getImageableHeight()/3;

	  bc.paint(graphics);
	  return 0;
  }

}
